/*
    bhex (Blacky's Hex-Editor)

    Dies ist ein einfacher Hexeditor fr die Console.

    Copyright (c) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/

*/



#include <curses.h>
#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <linux/fd.h>
#include "hofmeier.h"
#include <stdlib.h>

#include <errno.h>
#include <unistd.h>
#include <linux/fs.h>


char blacky_ver_info[] = "Blacky Hex Editor v0.30 (c) Copyright 1998-2003 Andreas Hofmeier";


/* FILE / Devise */
FILE *f;
/* Position in der Datei */
unsigned /*long*/ long pos = 0, ol = 0, size;
/* function zum Herunterfahren ! */
static void finish(int sig);
/* Functionen zum ndern der xTerm-Gre...*/
static void fg(int sig);
static void alarmf(int sig);
int zeilen = 24;
int zeichen = 80;
/* Floppy info */
//struct floppy_struct param;
/* Read-Only? */
char readonly = 0;
/* Modus 0 = View; 1 = Norm; 2 = Hex; 3 = Dez*/
char mod = 0;
// mod_dase: basis der Eingabe
// mod_dtype: Datentyp der Eingabe
int mod_base = 0;
int mod_dtype = 0;
int mod_dsize = 0;
char *mod_data;
char *mod_input[50];
/* Mak start */
char ismark = 0;
unsigned /*long*/ long  mark;
/* Mark write-append-file-name */
char *wafilename = NULL;
/* BUFFER im RAM */
char *rambuf = NULL;
unsigned /*long*/ long rambufsize = 0;
/* Zeichen oder Hex? */
char charhex = 1;
/* Such Str */
char *suchstr = NULL;
/* Filename */
char *filename;
/* Offset String */
char nposs[30];
/* Bei manchen Terminales (bei xterm), sehen wird ein schwartzes Feld,
   welches mit einem Schwartzem Feld (Markierung), ein Weies Feld
   bildet, Verwirrung */
int blockcursor = 0;

#define FLOPPY_MAJOR 2



arbeite(s)
  char *s;
{
  cleanline(zeilen - 2/*22*/);
  cleanline(zeilen - 1/*23*/);
  cleanline(zeilen    /*24*/);
  addstr(s);
  refresh();
  fflush(stdout);
}


cleanline(l)
int l;
{
  int i;

  gotoxy(1, l);
  for (i = 0; i < 80; i++) {
    addstr(" ");
  }
  gotoxy(1, l);
}


int blacky_gr_getchar(s, s2)
  char *s, *s2;
{
  int i;

  cleanline(zeilen - 2 /*22*/);
  gotoxy(1, zeilen - 2 /*22*/);
  addstr(s);
  addstr(s2);
  i = getch();
  cleanline(zeilen - 2 /*22*/);
  /*  paint();*/
  return i;
}


unsigned char asciitab(unsigned char z)
{
  unsigned char o = 0, s[100], pos;
  int i, key;

  makeline(LOECK, HLINE, ROECK, 1, 5);
  gotoxy(35, 5);
  addstr("Ascii - Tab");  
  makeline(VLINE, NOMBG, VLINE, 1, 6);
  gotoxy(3, 6);
  addstr("Dez  Hex  76543210  uZ  Z  Name");
  makeline(VLINE, NOMBG, VLINE, 1, 7);
  makeline(VLINE, NOMBG, VLINE, 1, 8);
  makeline(VLINE, NOMBG, VLINE, 1, 9);
  makeline(VLINE, NOMBG, VLINE, 1, 10);
  makeline(VLINE, NOMBG, VLINE, 1, 11);
  makeline(VLINE, NOMBG, VLINE, 1, 12);
  makeline(VLINE, NOMBG, VLINE, 1, 13);
  makeline(VLINE, NOMBG, VLINE, 1, 14);
  makeline(VLINE, NOMBG, VLINE, 1, 15);
  makeline(VLINE, NOMBG, VLINE, 1, 16);
  makeline(VLINE, NOMBG, VLINE, 1, 17);
  makeline(VLINE, NOMBG, VLINE, 1, 18);
  makeline(VLINE, NOMBG, VLINE, 1, 19);
  makeline(LUECK, HLINE, RUECK, 1, 20);

  pos = z;
  for (  ;  ;  )
    {
      if (pos < o)
	{
	  o = pos;
	}
      if (pos > (o + 12))
	{
	  o = pos - 12;
	}
      for (i = 7; i < 7 + 13; i++)
	{
	  unsigned char cc = i - 7 + o, vuz[3], vmakedc[9], vgetcharname[80];

	  gotoxy(3, i);
	  makedc(vmakedc, cc);
	  getcharname(vgetcharname, cc);
	  uz(vuz, cc);
	  sprintf(s, "%3d  %3x  %s  %2s  %c  %-49s", cc, cc, vmakedc, vuz,
		  /* ((cc < 32) || ((cc > 126) && (cc < 160))) */ (!isprint(cc))? '.' : cc, vgetcharname);
	  s[76] = 0;
	  addstr(s);
	}
      gotoxy(5, pos - o + 7);
      key = getch();
      switch (key)
	{
	  /* Tab - C-i */
	case 9:
	  return z;
	  break;

	  /* ENTER */
	case 13:
	  z = pos;
	  return z;
	  break;

	case 262:
	case 1: /* C-a */
	  pos = 0;
	  break;

	  /* END */
	case 360:
	case 5: /* C-e */
	  pos = 255;
	  break;

	  /* BILD UP */
	case 339:
	  if (pos < 12) {
	    pos = 0;
	  } else {
	    pos -= 12;
	  }
	  break;

	  /* BILD DN */
	case 338:
	  if (pos > 243) {
	    pos = 255;
	  } else {
	    pos += 12;
	  }
	  break;

	  /* up */
	case 259:
	case 'k':
	  pos--;
	  break;

	  /* dn */
	case 258:
	case 'j':
	  pos++;
	  break;

	default:
	  pos = (char) key;
	}
    }
}


blacky_gr_editstr(s, s2, al)
  char *s, *s2;
{
  cleanline(zeilen - 2/*22*/);
  addstr(s2);
  editstr(s, zeilen - 3/*21 /22*/, 1 + strlen(s2), al);
  cleanline(zeilen - 2/*22*/);
}


/*blacky_gr_statusline(s1, s2, s3)
  char *s1, *s2, *s3;
{
  cleanline(22);
  addstr(s1);
  cleanline(23);
  addstr(s2);
  cleanline(24);
  addstr(s3);
}*/


paint()
{
  unsigned char sl[100], buf[17], zbuf[7];
  int i, i2, ll, hr;
  unsigned char c;
  char uzz[3];

  for (i = 0; i < /*20*/ (zeilen - ((charhex != 2) ? 4 : 4 + 5)); i++)
    {
      rewind(f);
      fseek(f, (16 * i) + ol, 1);
      hr = (int) fread(buf, 1, 16, f);
      if ((((16 * i) + ol) + 16) > (size - 1))
	{
	  hr = 16 - ((((16 * i) + ol) + 16) - (size));
	}
      if (hr != 0)
	{
	  sprintf(sl, "%8x:  ", (16 * i) + ol);
	  for (i2 = 0; i2 < 16; i2++)
	    {
	      if (i2 == 7)
		{
		  if ((i2 + 1) > hr)
		    {
		      strcpy(zbuf, "   - ");
		    }
		  else
		    {
		      if (charhex == 0)
			{
			  uz(uzz, buf[i2]);
			  sprintf(zbuf, "%2s - ", uzz);
			}
		      else
			{
			  sprintf(zbuf, "%02X - ", buf[i2]);
			}
		    }
		}
	      else
		{
		  if ((i2 + 1) > hr)
		    {
		      strcpy(zbuf, "   ");
		    }
		  else
		    {
		      if (charhex == 0)
			{
			  uz(uzz, buf[i2]);
			  sprintf(zbuf, "%2s ", uzz);
			}
		      else
			{
			  sprintf(zbuf, "%02X ", buf[i2]);
			}
		    }
		}
	      strcat(sl, zbuf);
	    }
	  strcat(sl, " ");
	  ll = strlen(sl);
	  /* Rechter Block */
	  for (i2 = 0; i2 < 16; i2++)
	    {
	      if ((i2 + 1) > hr)
		{
		  sl[ll + i2] = ' ';
		}
	      else
		{
//		  if ((buf[i2] < 32) || ((buf[i2] > 126) && (buf[i2] < 160)))
		  if (!isprint(buf[i2]))
		    {
		      sl[ll + i2] = '.';
		    }
		  else
		    {
		      sl[ll + i2] = buf[i2];
		    }
		}
	    }
	  sl[ll + 16] = 0;
	  /* gotoxy(von links, von oben); beginnend bei 1; */
	  gotoxy(1, i + 1);
	  /* Wenn Markierung, anzeigen */
	  if (ismark == 1) {
	    unsigned long von, bis, l;
	    int ii;

	    von = (pos < mark) ? pos : mark;
	    bis = (pos < mark) ? mark : pos;
	    l = (ol + i * 16);

	    for (ii = 0; ii < 62; ii++)	{
	      addch(sl[ii]);
	    }
	    for (ii = 0; ii < 16; ii++)	{
	      if ((von <= (l + ii)) && ( ((blockcursor) ? bis - 1 : bis )>= (l + ii))) {
		attrset(A_REVERSE/*A_STANDOUT*/);
	      }

	      addch(sl[ii + 62]);
	      attrset(A_NORMAL);
	    }
	    addstr("   ");
	  } else {
	    addstr(sl);
	    addstr("   ");
	  }
	} else {
	  addstr("                                                                                      ");
	}
    }

  // Spezielle angaben
  if (charhex == 2) {
    static char s[81];
    static char dat[4];
    int i, si;
    int j;
    int i0, i1;
    char *i0str = (char *) &i0, *i1str = (char *) &i1;
    unsigned long lu;
    signed long ls;
    char *lustr = (char *) &lu, *lsstr = (char *) &ls;

    rewind(f);
    fseek(f, pos, 1);
    fread(dat, 1, 4, f);

    sprintf(s, "DUAL                     HSB xxxx xxxx  xxxx xxxx  xxxx xxxx  xxxx xxxx LSB");
    si = 29;
    for (i = 3; i >=0; i--) {
      for (j = 128; j > 0; j = j / 2) {
	if ((dat[i] & j) > 0) {
 	  s[si] = '1';
	} else {
 	  s[si] = '0';
	}
	si++;
	if (j == 16) {
	  si++;
	}

	if (j == 1) {
	  si++;
	  si++;
	  break;
	}
      }
    }
    cleanline(zeilen - 8);
    addstr(s);

    sprintf(s, "HEX per 4Bit                 %4X %4X  %4X %4X  %4X %4X  %4X %4X", ((dat[3] & 240) / 2 / 2 / 2 / 2), (dat[3] & 15), ((dat[2] & 240) / 2 / 2 / 2 / 2), (dat[2] & 15), ((dat[1] & 240) / 2 / 2 / 2 / 2), (dat[1] & 15), ((dat[0] & 240) / 2 / 2 / 2 / 2), (dat[0] & 15));
    cleanline(zeilen - 7);
    addstr(s);
    
    sprintf(s, "unsigned char DEZ/OKT        %4d /%3o  %4d /%3o  %4d /%3o  %4d /%3o", (unsigned char) dat[3], (unsigned char) dat[3], (unsigned char) dat[2], (unsigned char) dat[2], (unsigned char) dat[1], (unsigned char) dat[1], (unsigned char) dat[0], (unsigned char) dat[0]);
    cleanline(zeilen - 6);
    addstr(s);

    i0 = i1 = 0;
    i1str[0] = dat[0];
    i1str[1] = dat[1];
    i0str[0] = dat[2];
    i0str[1] = dat[3];

    //    sprintf(s, "signed char/int 16Bit/s.c.   %4d /%8d/ %4d  %4d /%8d/ %4d  %4d /%8d/ %4d  %4d /%8d/ %4d", (signed int) ((signed char) dat[3]), i0, (signed int) (signed char) dat[2], (signed int) (signed char) dat[1], i1, (signed int) (signed char) dat[0]);
    sprintf(s, "signed char/int 16Bit/s.c.   %4d /%8d/ %4d  %4d /%8d/ %4d", (signed char) dat[3], i1, (signed char) dat[2], (signed char) dat[1], i0, (signed char) dat[0]);
    cleanline(zeilen - 5);
    addstr(s);

    lustr[0] = lsstr[0] = dat[0];
    lustr[1] = lsstr[1] = dat[1];
    lustr[2] = lsstr[2] = dat[2];
    lustr[3] = lsstr[3] = dat[3];
    sprintf(s, "signed / unsigned long       %20ld  %20lu", ls, lu);
    cleanline(zeilen - 4);
    addstr(s);
  }


  /* Status - Line */
  cleanline(zeilen - 2 /*22*/);
  gotoxy(1, zeilen - 2 /*22*/);
  rewind(f);
  fseek(f, pos, 1);
  fread(&c, 1, 1, f);
  sprintf(sl, "%10u / %10u = %03d", pos, (size - 1), c);
  addstr(sl);
  if (readonly)
    {
      gotoxy(32, zeilen - 2 /*22*/);
      addstr("%%");
    }
  gotoxy(32, zeilen - 2 /*22*/);
  if (mod != 0)
    {
      if (mod == 1)
	addstr("** Eingabe mod!");
      if (mod == 2)
	addstr("** HEX - Eingabe mod!");
      if (mod == 3)
	addstr("** Dez. - Eingabe mod!");
      if (mod == 4)
	addstr("** Self-Defind - Eingabe mod! (* to Configure)");
    }
  else
    {
      if (readonly)
	{
	  gotoxy(36, zeilen - 2 /*22*/);
	}
      addstr(filename);
    }
  gotoxy(73, zeilen - 2 /*22*/);
  i = (int) ((double) ((double) ((double) pos / (double) (size - 1)) * (double) 100) );
  i++;
  if (i > 100)
    {
      i = 100;
    }
  sprintf(sl, "  %3d%%", (char) i);
  addstr(sl);
  /* Scrollbar */
  i = (int) ((double long) (zeilen - /*4*/((charhex != 2) ? 4 : 4 + 5)) /*20*/ * ((double long) (pos) / (double long) (size - 1)));
  i++;
  if (i > (zeilen - /*4*/((charhex != 2) ? 4 : 4 + 5)) /*20*/)
    {
      i = (zeilen - /*4*/((charhex != 2) ? 4 : 4 + 5)) /*20*/;
    }
  /*  gotoxy(80, (int) ( (double long) 0,2 * (double long) i )); */
  gotoxy(80, i);
  addstr("#");
  /* Andre... */
  gotoxy(1, zeilen - 3 /*21*/);
  attrset(A_STANDOUT);
  addstr("Blacky's  HEX-Editor  (c)  Copyright  by  Andreas  Hofmeier  Computer  Programme");
  attrset(A_NORMAL);
  /* Menu... */
  /*  gotoxy(1, 21);*/
  /* Mark */
  if (ismark == 1)
    {
      char c[100];

      cleanline(zeilen - 1 /*23*/);
      sprintf(c, "Mark: (von %10d bis %10d) %10d", mark, pos, (pos < mark) ? mark - pos + 1 : pos - mark + 1);
      addstr(c);
      /* Help-Line */
      gotoxy(1, zeilen /*24*/);
      addstr("m - Neu; e - Ende; w - write to file; a - append to file; c - copy; o - berschr.");
    }
  else
    {
      cleanline(zeilen - 1 /*23*/);
      cleanline(zeilen     /*24*/);
      /* Help-Line */
      if (mod == 0)
	{
	  addstr("<-,->,up,dn,home,end - Select; ENTER - Goto; (n)/ - (w)Suchen; tab - Asciitab");
	  gotoxy(1, zeilen - 1 /*23*/);
	  addstr("x - Exit; m - Mark; c - Past; INS - Eingabemod; o - berschreiben mit!; z - ");
	  addstr((charhex == 0) ? "Char" : "Hex");
	}
      else
	/* Help - Mode */
	{
	  if (mod == 1)
	    {
	      addstr("Ascii-Zeichen werden direckt auf die Datei geschrieben!");
	    }
	  if (mod == 2)
	    {
	      addstr("Geben Sie Hex-Dezimal ein (z.B. f4), die geschrieben werden sollen!");
	    }
	  if (mod == 3)
	    {
	      addstr("Geben Sie Dezimal ein (z.B. 124), die geschrieben werden sollen!");
	    }
	  if (mod == 4)
	    {
	      static char str[128];
	      switch (mod_dtype) {
	      case 0:
		sprintf(str, "BASE: %d; SIZEOF(char) %d Byte  %d Bit", mod_base, mod_dsize, mod_dsize * 8);
		break;
	      case 1:
		sprintf(str, "BASE: %d; SIZEOF(unsigned char) %d Byte  %d Bit", mod_base, mod_dsize, mod_dsize * 8);
		break;
	      case 2:
		sprintf(str, "BASE: %d; SIZEOF(int) %d Byte  %d Bit", mod_base, mod_dsize, mod_dsize * 8);
		break;
	      case 3:
		sprintf(str, "BASE: %d; SIZEOF(long) %d Byte  %d Bit", mod_base, mod_dsize, mod_dsize * 8);
		break;
	      case 4:
		sprintf(str, "BASE: %d; SIZEOF(unsigned long) %d Byte  %d Bit", mod_base, mod_dsize, mod_dsize * 8);
		break;
	      } /* switch() */
	      addstr(str);
	    }
	}
    }
  /* cursor */

#ifdef BLACKY_cur_Graphik
  rewind(f);
  //  if ((unsigned long int) pos < (unsigned long int) 2147483648) {
    fseek(f, pos, 1);
    /*  } else {
    fseek(f, (unsigned long int) 2147483648, 1);
    fseek(f, (pos - (unsigned long int) 2147483648), 0);
    }*/
  fread(&c, 1, 1, f); 
#endif

  for (i = 0; i < (zeilen - /*4*/((charhex != 2) ? 4 : 4 + 5)) /*20*/; i++)
    {
      if ((pos >= ((16 * i) + ol)) && (pos <= ((16 * i) + ol + 15)))
	{
	  if ((pos - ((16 * i) + ol) > 7))
	    {
#ifndef BLACKY_cur_Graphik
	      gotoxy(13 + 3 * (pos - ((16 * i) + ol)), i + 1);
	      addstr(">");
	      gotoxy(16 + 3 * (pos - ((16 * i) + ol)), i + 1);
	      addstr("<");
#endif
#ifdef BLACKY_cur_Graphik
	      attrset(A_STANDOUT);
	      gotoxy(14 + 3 * (pos - ((16 * i) + ol)), i + 1);
	      if (charhex == 0)
		{
		  uz(uzz, c);
		  sprintf(zbuf, "%2s", uzz);
		}
	      else
		{
		  sprintf(zbuf, "%02X", c);
		}
	      addstr(zbuf);
	      attrset(A_NORMAL);
#endif
	    }
	  else
	    {
#ifndef BLACKY_cur_Graphik
	      gotoxy(11 + 3 * (pos - ((16 * i) + ol)), i + 1);
	      addstr(">");
	      gotoxy(14 + 3 * (pos - ((16 * i) + ol)), i + 1);
	      addstr("<");
#endif
#ifdef BLACKY_cur_Graphik
	      attrset(A_STANDOUT);
	      gotoxy(12 + 3 * (pos - ((16 * i) + ol)), i + 1);
	      if (charhex == 0)
		{
		  uz(uzz, c);
		  sprintf(zbuf, "%2s", uzz);
		}
	      else
		{
		  sprintf(zbuf, "%02X", c);
		}
	      addstr(zbuf);
	      attrset(A_NORMAL);
#endif
	    }
	  gotoxy(63 + pos - ((16 * i) + ol), i + 1);
	}
    }
  /* "00000000:  2E 20 20 20 20 20 20 20 - 20 20 20 10 00 00 00 00 .          >...." */
}


static int valid_offset(int fd, unsigned long offset)
{
  char ch;

  if (lseek(fd, offset, 0) < 0)
    {
      return false;
    }
  if (read (fd, &ch, 1) < 1)
    {
      return false;
    }
  return true;
}


main(argc, argv)
  int argc;
  char *argv[];
{
  int key;
  /* "00000000:  2E 20 20 20 20 20 20 20 - 20 20 20 10 00 00 00 00 .          >...." */


  allblackyintro(blacky_ver_info);

  if ((argc < 2) ? 1 : (((argv[1][1] == '?') || (toupper(argv[1][1]) == 'H')) && (argv[1][0] == '-'))) {
    fprintf(stderr, "Help:\n");
    fprintf(stderr, "  bhex <-t | file oder device [-ro] [-s <size>]>\n");
    fprintf(stderr, "    -ro    : Schreibgeschtzt ffnen!\n");
    fprintf(stderr, "    -s size: Giebt die Lnge des dev's an(Bei Falscherkennung!).\n");
    fprintf(stderr, "    -t     : Zeigt nur die ASCII-Tabelle\n");
    fprintf(stderr, "    -v     : Version, Licenze\n");
    exit(1);
  }

  if ((argc == 2) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) : 0) {
    printf("%s\n\n", blacky_ver_info);
    printkinfo(stdout);
    exit(0);
  }

  if ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'T')) {
    init_cur_graph();

    /* x-Term-Titel */
    blacky_xterm_set_titel("Blacky Hex Editor - ASCII-TAB", 0L);

    gotoxy(1, 1);
    addstr("Blacky's HEX-Editor (c) Copyright by Andreas Hofmeier");
    gotoxy(1, 2);
    addstr("ENTER Exit");
      
    asciitab(0);

    endwin();
    blacky_xterm_set_titel("xterm", 0L);
    exit(1);
  }
  
  filename = argv[1];
  
  size = 0;
  readonly = 0;
  if (argc > 2) {
    for (key = 2; key < argc; key++) {
      if (strcmp(argv[key] + 1, "ro") == 0) {
	readonly = 1;
      }
      if (strcmp(argv[key] + 1, "s") == 0) {
	key++;
	/*size = atol(argv[key]);*/
	//size = (unsigned long int) strtoul((char *) argv[key], (char *) (argv[key] + strlen(argv[key])), 10);
	sscanf(argv[key], "%uL", &size);
      }
    }
  }

  // Try open RW
  if (readonly) {
    f = NULL;
  } else {
    if ((f = fopen(filename, "r+")) == NULL) {
      perror(filename);
    }
  }
  // Try open R
  if (f == NULL) {
    f = fopen(filename, "r");
    readonly = 1;
  }
  // Cant't OPEN FILE
  if (f == NULL) {
    fprintf(stderr, "** Fehler ** : Konnte die Datei %s nicht ffnen!\n", argv[1]);
    perror(filename);
    exit(0);
  }

  /* Lnge der Datei oder der Diskette */
  if (size == 0) {
    /* Gere ermitteln!*/
    /*size = filelen(filename);*/ /* Geht nur mit Long nicht mit unsigned long!*/
    struct stat buf;
    int fd;

    fd = fileno(f);
    fstat(fd, &buf);
    /* Block-Device-Prfen */
    if (buf.st_size < 0) {
      unsigned long high, low;

      low = 0;
      for (high = 1; valid_offset(fd, high); high *= 2) {
	low = high;
      }
      while(low < high - 1) {
	const int mid = (low + high) / 2;
	if (valid_offset(fd, mid)) {
	  low = mid;
	} else {
	  high = mid;
	}
      }
      valid_offset(fd, 0);

      size = (low == 0) ? 0 : low + 1;
    } else {
      size = buf.st_size;
    }
  }
  if (size == 0) {
    size = filelen(filename);
  }
  //  printf("Size: %uBytes\n", size);

  if (size > (1024 * 1024 * 1024)) {
    printf("Size: %uGByte (*1024*1024*1024 = Byte)\n", size/1024/1024/1024);
  } else {
    if (size > (1024 * 1024)) {
      printf("Size: %uMByte (*1024*1024 = Byte)\n", size/1024/1024);
    } else {
      if (size > 1024) {
	printf("Size: %uKByte (*1024 = Byte)\n", size/1024);
      } else {
	printf("Size: %uBytes\n", size);
      }
    }
  }

  if (size < 2) {
    fprintf(stderr, "Die Datei mu mindestens 2 Bytes lang sein!\n");
    exit(1);
  }

  /* x-Term-Titel */
  blacky_xterm_set_titel("Blacky Hex Editor", filename);

  /* Interrups vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */
  signal(SIGALRM, alarmf);      /* 14  /  Alarm      - wenn gesetzte Zeit abgelaufen ist */
  /* Fenstergre gendert? */
  signal(SIGWINCH, fg);         /* 28  /  ?          - grennderund des xTerms         */

  init_cur_graph();

  zeilen = LINES;
  zeichen = COLS;

  endwin();

  /* Sihe bei blockcursor... */
  if (strcmp(getenv("TERM"), "xterm") == 0) {
    blockcursor = 1;
  }

  for (  ;  ;  )
    {
      paint();
      //    fpurge(stdin);
      key = getch();
      /*fprintf(stderr, "--->%d<>%d<>%d<---", key, mod, readonly);*/
      if ((mod == 1) && (!readonly))
	{
	  if ((key > 31) && (key < 256))
	    {
	      unsigned char c;

	      c = (char) key;
	      rewind(f);
	      fseek(f, pos, 1);
	      fwrite(&c, 1, 1, f);
	      pos++;
	      key = 0;
	    }
	}
      if ((mod == 2) && (!readonly))
	{
	  if (((key > 47) && (key < 58)) || ((key > 64) && (key < 71)) || ((key > 96) && (key < 103)) || (key == ' '))
	    {
	      unsigned char s[10], c;

	      s[0] = (char) key;
	      s[1] = 0;
	      key = blacky_gr_getchar("Hex-Dezimal: ", s);
	      if (((key > 47) && (key < 58)) || ((key > 64) && (key < 71)) || ((key > 96) && (key < 103)) || (key == ' '))
		{
		  s[1] = (char) key;
		  s[2] = 0;
		  sscanf(s, "%x", &c);
		  rewind(f);
		  fseek(f, pos, 1);
		  fwrite(&c, 1, 1, f);
		  pos++;
		  key = 0;
		}
	    }
	}
      if ((mod == 3) && (!readonly))
	{
	  if (isdigit((char) key))
	    {
	      unsigned char s[10], c;

	      s[0] = (char) key;
	      s[1] = 0;
	      blacky_gr_editstr(s, "Dezimal: ", 1);
	      if (s[0] != 0)
		{
		  sscanf(s, "%d", &c);
		  rewind(f);
		  fseek(f, pos, 1);
		  fwrite(&c, 1, 1, f);
		  pos++;
		  key = 0;  
		}
	    }
	}
      if ((mod == 4) && (!readonly))
	{
	  if (key != 331) {
	    if ((mod_base == 0) /*|| (mod_dtype == 0)*/ || (key == '*')) {
	      endwin();
	      printf("Konfigurieren der Eingabe: \n");
	      printf("  Geben Sie die Basis ein: \n");
	      printf("    BASEN:  2: Dual\n");
	      printf("            8: Oktal\n");
	      printf("           10: Dezimal\n");
	      printf("           16: Hexadezimal\n");
	      printf("           (andere Mglich)\n");
	      fflush(stdout);
	      scanf("%d", &mod_base);
	      printf("  Geben Sie den Daten-Type ein: \n");
	      printf("    Tyte:  0: char                %2dByte   %3dBit\n", sizeof(char), sizeof(char) * 8);
	      printf("    Tyte:  1: unsigned char       %2dByte   %3dBit\n", sizeof(unsigned char), sizeof(unsigned char) * 8);
	      printf("    Tyte:  2: int                 %2dByte   %3dBit\n", sizeof(int), sizeof(int) * 8);
	      printf("    Tyte:  3: long                %2dByte   %3dBit\n", sizeof(long), sizeof(long) * 8);
	      printf("    Tyte:  4: unsigned long       %2dByte   %3dBit\n", sizeof(unsigned long), sizeof(unsigned long) * 8);
	      fflush(stdout);
	      
	      scanf("%d", &mod_dtype);
	      
	      switch (mod_dtype) {
	      case 0:
		mod_dsize = sizeof(char);
		mod_data = (char *) malloc(mod_dsize);
		break;
	      case 1:
		mod_dsize = sizeof(unsigned char);
		mod_data = (char *) malloc(mod_dsize);
		break;
	      case 2:
		mod_dsize = sizeof(int);
		mod_data = (char *) malloc(mod_dsize);
		break;
	      case 3:
		mod_dsize = sizeof(long);
		mod_data = (char *) malloc(mod_dsize);
		break;
	      case 4:
		mod_dsize = sizeof(unsigned long);
		mod_data = (char *) malloc(mod_dsize);
		break;
	      } /* switch() */
	    }
	    
	    
	    
	    if (((isalnum((char) key)) || (key == '+') || (key == '-')) && (key != 331))
	      {
		char *s = mod_data;
		
		s[0] = (char) key;
		s[1] = 0;
		blacky_gr_editstr(s, "InPut: ", 1);
		if (s[0] != 0)
		  {
		    //		  sscanf(s, "%d", &c);
		    char c_char;
		    unsigned char c_uchar;
		    int c_int;
		    long c_long;
		    unsigned c_ulong;
		    
		    
		    rewind(f);
		    fseek(f, pos, 1);
		    
		    switch (mod_dtype) {
		    case 0:
		      c_long = strtol(s, (char **) s + strlen(s), mod_base);
		      c_char = (char) c_long;
		      fwrite(&c_char, 1, mod_dsize, f);
		      pos += mod_dsize;
		      break;
		    case 1:
		      c_long = strtol(s, (char **) s + strlen(s), mod_base);
		      c_uchar = (unsigned char) c_long;
		      fwrite(&c_uchar, 1, mod_dsize, f);
		      pos += mod_dsize;
		      break;
		    case 2:
		      c_long = strtol(s, (char **) s + strlen(s), mod_base);
		      c_int = (int) c_long;
		      fwrite(&c_int, 1, mod_dsize, f);
		      pos += mod_dsize;
		      break;
		    case 3:
		      c_long = strtol(s, (char **) s + strlen(s), mod_base);
		      fwrite(&c_long, 1, mod_dsize, f);
		      pos += mod_dsize;
		      break;
		    case 4:
		      c_ulong = strtoul(s, (char **) s + strlen(s), mod_base);
		      fwrite(&c_ulong, 1, mod_dsize, f);
		      pos += mod_dsize;
		      break;
		    } /* switch() */
		    
		    key = 0;
		  }
	      }
	  }
	}

      switch (key)
	{
	  /* Redraw - Space */
	case ' ':
	case 12:
	  endwin();
	  paint();
	  break;

	  /* EXIT */
	case 'x':
	case 'q':
	  finish(0);
	  break;
	  
	  /* berschreiben mit */
	case 'o':
	case 'O':
	  {
	    unsigned char s[100], c;
	    unsigned long l, l2;

	    if (readonly) break;
	    if (ismark == 0)
	      {
		s[0] = 0;
		cleanline(zeilen - 1 /*23*/);
		cleanline(zeilen /*24*/);
		blacky_gr_editstr(s, "ENTER Anzahl der Bytes die berschrieben werden sollen: ", 0);
		if (s[0] == 0) break;
		if ((s[0] == '0') && (s[1] == 'x'))
		  {
		    sscanf(s + 2, "%x", &l);
		  }
		else
		  {
		    sscanf(s, "%d", &l);
		  }
	      }
	    else
	      {
		l = (pos < mark) ? mark - pos + 1 : pos - mark + 1;
	      }
	    s[0] = 0;
	    cleanline(zeilen - 1 /*23*/);
	    blacky_gr_editstr(s, "ENTER Zeichen mit dem berschrieben werden soll (Dez, 0x=Hex)(. - menu): ", 0);
	    if (s[0] == 0) break;
	    if ((s[0] == '.') && (s[1] == 0)) {
	      cleanline(zeilen - 1/*23*/);
	      cleanline(zeilen /*24*/);
	      addstr("Ascii-Tab: ENTER - Auswahl");
	      c = asciitab(0);
	    } else {
	      if ((s[0] == '0') && (s[1] == 'x')) {
		sscanf(s + 2, "%x", &l2);
	      }	else {
		sscanf(s, "%d", &l2);
	      }
	      c = (char) l2;
	    }

	    if (ismark == 1) {
	      pos = (mark < pos) ? mark : pos;
	    }
	    paint();
	    cleanline(zeilen - 1/*23*/);
	    sprintf(s, "Wollen Sie wirklich die folgenden %d Bytes mit 0x%x berschreiben? (Y/N): ", l, c);
	    l2 = (unsigned long) toupper(blacky_gr_getchar(s, ""));
	    if (((char) l2 != 'Y') && ((char) l2 != 'J')) {
	      break;
	    }
	    arbeite("berschreibe...");
	    rewind(f);
	    fseek(f, pos, 1);
	    for (l2 = 0; l2 < l; l2++) {
	      if ((l2 + pos) >= size) break;
	      fwrite(&c, 1, 1, f);
	    }
	    ffsync(f);
	    pos = pos + l;
	  }
	  break;

	  /* Mark */
	case 'm':
	case 'M':
	  mark = pos;
	  ismark = 1;
	  break;

	  /* END MARK */
	case 'e':
	case 'E':
	  ismark = 0;
	  break;

	  /* Mark - Copy to Ram (im mark mode) - OwerWrite with Rambuf (normal mode) */
	case 'c':
	case 'C':
	  {
	    if (ismark == 0)
	      {
		unsigned char mull[80], c;

		sprintf(mull, "** berschreiben? (Y: mit Rambuffer (%d Bytes)/F: mit Datei/N) ?", rambufsize);
		c = toupper((char) blacky_gr_getchar(mull, ""));
		if (c == 'F') {
		  char s[500];
		  FILE *q;

		  s[0] = 0;
		  blacky_gr_editstr(s, "Filename: ", 0);
		  if ((q = fopen(s, "r")) == NULL) {
		    blacky_gr_getchar("** Konnte Datei nicht ffnen **", "");
		  } else {
		    int BUFSIZE = 1024;
		    int i;
		    char buf[BUFSIZE];

		    rewind(f);
		    fseek(f, pos, 1);
		    while (!feof(q)) {
		      i = fread(buf, 1, BUFSIZE, q);
		      fwrite(buf, 1, i, f);
		      pos += i;
		    }
		    ffsync(f);
		  }
		  break;
		}
		if ((rambufsize == 0) || (rambuf == NULL)) break;
		if ((c != 'Y') && (c != 'J'))
		  {
		    break;
		  }
		arbeite("Schreibe...");
		rewind(f);
		fseek(f, pos, 1);
		fwrite(rambuf, rambufsize, 1, f);
		ffsync(f);
		pos = pos + rambufsize;
		break;
	      }
	    rambufsize = (pos < mark) ? mark - pos + 1 : pos - mark + 1;
	    free(rambuf);
	    rambuf = (char *) malloc(rambufsize);
	    if (rambuf == NULL)
	      {
		blacky_gr_getchar("** Nicht genug Speicher **", "");
		rambufsize = 0;
		break;
	      }
	    arbeite("Lese...");
	    rewind(f);
	    fseek(f, (pos > mark) ? mark : pos, 1);
	    fread(rambuf, rambufsize, 1, f);
	  }
	  break;

	  /* Mark - write to file | append to file */
	case 'w':
	case 'W':
	case 'a':
	case 'A':
	  if (ismark == 0) break;
	  {
	    FILE *ziel;
	    char s[300];

	    s[0] = 0;
	    if (wafilename != NULL)
	      {
		strcpy(s, wafilename);
	      }
	    blacky_gr_editstr(s, "ENTER File Name: ", 1);
	    if (s[0] != 0)
	      {
		if (wafilename != NULL) free(wafilename);
		if ((wafilename = (char *) malloc(strlen(s) + 1)) == NULL) {
		  perror("malloc()");
		  exit(0);
		}
		//		ps(wafilename);
		strcpy(wafilename, s);
		if (toupper(key) == 'W')
		  {
		    if (filelen(s) > 0)
		      {
			unsigned char c;
			
			c = toupper((unsigned char) blacky_gr_getchar("Datei berschreiben?(Y/N) ", s));
			if ((c != 'Y') && (c != 'J'))
			  {
			    break;
			  }
		      }
		    ziel = fopen(s, "w");
		  }
		else
		  {
		    unsigned long l;

		    l = filelen(s);
		    ziel = fopen(s, "r+");
		    rewind(ziel);
		    fseek(ziel, l, 1);
		  }
		if ((f == NULL) || (ziel == NULL))
		  {
		    blacky_gr_getchar("** Fehler ** : Dateizugriffs-Fehler: ", (ziel == NULL) ? s : filename);
		    break;
		  }
		else
		  {
		    unsigned long BUFSIZE = 1000000, i;
		    char buf[BUFSIZE];
		    long ges;
		    char anz = 0, nanz;

		    arbeite("Lese von Disk und Schreibe in Datei...");
		    rewind(f);
		    fseek(f, (pos > mark) ? mark : pos, 1);
		    i = (pos < mark) ? mark - pos + 1 : pos - mark + 1;

		    ges = i;
		    gotoxy(1, zeilen - 1 /*23*/);
		    sprintf(buf, "000% (%d Bytes) 1MB-Schritten", ges);
		    addstr(buf);
		    refresh();
		    fflush(stdout);

		    for (  ; (int) i > (int) 0; )
		      {
			nanz = (char) ((double) ((double) ((double) ((double) ges - (double) i) / (double) ges) * (double) 100) );
			if (nanz != anz)
			  {
			    anz = nanz;
			    gotoxy(1, zeilen - 1 /*23*/);
			    sprintf(buf, "%3d", anz);
			    addstr(buf);
			    refresh();
			    fflush(stdout);
			  }
			fread(buf, (i >= BUFSIZE) ? BUFSIZE : i, 1, f);
			fwrite(buf, (i >= BUFSIZE) ? BUFSIZE : i, 1, ziel);
			i -= BUFSIZE;
		      }
		    ffsync(ziel);
		    fclose(ziel);
		  }
	      }
	  }
	  break;

	  /* HOME */
	case 262:
	case 1: /* C-a */
	  pos = 0;
	  ol = 0;
	  break;

	  /* ENTER new pos */
	case 13:
	  {
	    unsigned long npos;

	    /*	    nposs[0] = 0;*/
	    blacky_gr_editstr(nposs, "ENTER Pos (+[-]* Draufrechnen[negativ]/0x* Hex/*% inProzent): ", (nposs[0] == '+') ? 1 : 0);
	    if (nposs[0] != 0) {
	      char drauf = 0;
	      if (nposs[0] == '+') {
		drauf = 1;
		if (nposs[1] == '-') {
		  drauf = 2;
		}
	      }
	      if ((nposs[0 + drauf] == '0') && (nposs[1 + drauf] == 'x')) {
		sscanf(nposs + 2 + drauf, "%x", &npos);
	      } else {
		sscanf(nposs + drauf, "%d", &npos);
	      }
	      if (nposs[strlen(nposs) - 1] == '%') {
		npos = (unsigned long) ((double) ((double) npos * (double) size / (double) 100));
	      }
	      if (drauf != 0) {
		if (drauf == 1) {
		  pos = pos + npos;
		} else {
		  pos = pos - npos;
		}
	      }	else {
		pos = npos;
	      }
	    }
	  }
	  break;

	  /* Eingabe mode */
	case 331:
	case 'i':
	case 'I':
	  if (readonly) break;
	  mod++;
	  if (mod > 4)
	    {
	      ffsync(f);
	      mod = 0;
	    }
	  break;

	  /* Zeichen oder Hex? */
	case 'z':
	case 'Z':
	  //	  charhex = (charhex == 0) ? 1 : 0;
	  if (charhex == 0) {
	    charhex = 2;
	  } else {
	    if (charhex == 1) {
	      charhex = 0;
	    } else {
	      charhex = 1;
	    }
	  }
	  /*
	  charhex += 1;
	  if (charhex > 2) {
	    charhex = 0;
	  }
	  */
	  break;
	  /* END */
	case 360:
	case 5: /* C-e */
	  pos = size - 1;
	  break;

	  /* -> */
	case 261:
	case 'l':
	  pos++;
	  break;

	  /* BILD UP */
	case 339:
	  if (ol > (/*20*/ (zeilen - /*4*/((charhex != 2) ? 4 : 4 + 5)) * 16))
	    {
	      ol -= ((zeilen - /*4*/((charhex != 2) ? 4 : 4 + 5))/*20*/ * 16);
	      pos -= ((zeilen - /*4*/((charhex != 2) ? 4 : 4 + 5))/*20*/ * 16);
	    }
	  else
	    {
	      pos = ol = 0;
	    }
	  break;

	  /* BILD DN */
	case 338:
	  /*	  if (ol > (20 * 16))*/
	    {
	      ol += ((zeilen - /*4*/((charhex != 2) ? 4 : 4 + 5))/*20*/ * 16);
	      pos += ((zeilen - /*4*/((charhex != 2) ? 4 : 4 + 5))/*20*/ * 16);
	      if (pos >= size)
		{
		  pos = size - 1;
		  ol = 0;
		}
	    }
	  break;

	  /* <- */
	case 260:
	case 'h':
	  if (pos > 0)
	    {
	      pos--;
	    }
	  break;

	  /* up */
	case 259:
	case 'k':
	  if (pos > 15) {
	    pos -= 16;
	  } else {
	    pos = 0;
	  }
	  break;

	  /* Enter Sector, Track, Head - C-f */
	case 6:
	  {
	    char s[30];
	    int sector, track, head;

	    s[0] = 0;
	    blacky_gr_editstr(s, "ENTER Sector: ", 0);
	    if (s[0] == 0) break;
	    sscanf(s, "%d", &sector);

	    s[0] = 0;
	    blacky_gr_editstr(s, "ENTER Track: ", 0);
	    if (s[0] == 0) break;
	    sscanf(s, "%d", &track);

	    s[0] = 0;
	    blacky_gr_editstr(s, "ENTER Head: ", 0);
	    if (s[0] == 0) break;
	    sscanf(s, "%d", &head);
	    
	    pos = (512 * (head + 1) * (track + 1) * (sector + 1)) - 1;
	  }
	  break;

	  /* dn */
	case 258:
	case 'j':
	  if (pos > (size - 16)) {
	    pos = size - 1;
	  } else {
	    pos += 16;
	  }
	  break;

	  /* Suchen */
	case '/':
	case 'n':
	case 'N':
	  {
	    unsigned long pp;
	    char s[300];

	    if (key == '/')
	      {
		if (suchstr == NULL)
		  {
		    s[0] = 0;
		  }
		else
		  {
		    strcpy(s, suchstr);
		  }
		blacky_gr_editstr(s, "Suche nach: ", 0);
		if (s[0] == 0)
		  {
		    break;
		  }
		free(suchstr);
		if ((suchstr = (char *) malloc(strlen(s) + 1)) == NULL) {
		  perror("malloc()");
		  exit(0);
		}
		//		ps(suchstr);
		Gross(suchstr, s);
	      }
	    if (suchstr != NULL)
	      {
		unsigned char c;
		int ssl = strlen(suchstr);

		arbeite("Suche...");
		rewind(f);
		fseek(f, pos + 1, 1);
		for (pp = pos + 1; pp != pos;  ) {
		  if (pp >= size) {
		    pp = 0;
		    rewind(f);
		    continue;
		  }
		  pp++;
		  if (fread(&c, 1, 1, f) != 1) break;
		  if (toupper(c) == suchstr[0]) {
		    int xl;
		    // Nur Ein Zeichen im SuchStr
		    if (suchstr[1] == 0) {
		      //		      xl = ssl;
		      rewind(f);
		      fseek(f, pp, 1);

		      pos = pp + 1;
		      break;
		    }
		    // Mehr als ein Zeichen, rest vergleichen...
		    fread((s + 1), ssl - 1, 1, f);
		    for (xl = 1; xl < ssl; xl++) {
		      if (toupper(s[xl]) != suchstr[xl]) {
			xl = ssl;
			rewind(f);
			fseek(f, pp, 1);
			continue;
		      }
		      if (xl == (ssl - 1)) {
			pos = pp + 1;
			break;
		      }
		    }
		  }
		}
	      }
	  }
	  pos -= 2;
	  break;

	case 9: /* C-i */
	  {
	    unsigned char c, c2;

	    rewind(f);
	    fseek(f, pos, 1);
	    fread(&c, 1, 1, f);
	    cleanline((zeilen - 1) /*23*/);
	    cleanline(zeilen/*24*/);
	    addstr("Ascii-Tab: Tab - Exit; ");
	    if ((mod != 0) && (!readonly))
	      {
		addstr("ENTER - Byte-Schreiben");
	      }

	    c2 = asciitab(c);

	    if ((c2 != c) && (mod != 0) && (!readonly))
	      {
		rewind(f);
		fseek(f, pos, 1);
		fwrite(&c2, 1, 1, f);
	      }
	  }
	  break;

	}
      if (pos < 0)
	{
	  pos = 0;
	}
      if (pos < ol)
	{
	  char *c;

	  ol = pos;
	  c = (char *) &ol;
	  c[0] = c[0] & 240;
	}
      if (pos >= (size - 1))
	{
	  pos = (size - 1);
	}
      if (pos + 1 > (ol + ((zeilen - /*4*/((charhex != 2) ? 4 : 4 + 5))/*20*/ * 16)))
	{
	  char *c;

	  ol = pos - ((zeilen - /*5*/(((charhex != 2) ? 4 : 4 + 5) + 1))/*19*/ * 16);
	  c = (char *) &ol;
	  c[0] = c[0] & 240;
	}
    }
  finish(0);
}


static void finish(int sig)
{
  /* Herrunterfahren */
  endwin();

  /* x-Term-Titel */
  blacky_xterm_set_titel("xterm", 0L);

  exit(0);
}


static void fg(int sig)
{
  char s[50];

  signal(SIGWINCH, fg);
  /*  alarm(1);

      endwin();*/

  endwin();
  refresh();
  zeilen = LINES;
  zeichen = COLS;
  endwin();
  paint();
  refresh();
}


static void alarmf(int sig)
{
  signal(SIGALRM, alarmf);

  zeilen = LINES;
  zeichen = COLS;
  paint();
}
